"""Simple pyrex binding for system shutdown syscall."""
cdef extern from "sys/reboot.h":
    int _reboot "reboot" (int flag)
    enum:
        RB_AUTOBOOT,
        RB_HALT_SYSTEM,
        RB_POWER_OFF
cdef extern from "errno.h":
    int errno
cdef extern from "string.h":
    char *strerror(int errnum)

def reboot():
    """Reboot the machine immediately.
    If no sync is done first, data will be lost."""
    st = _reboot(RB_AUTOBOOT)
    if st != 0:
        raise OSError, (errno, strerror(errno))     
def halt():
    """Halt the machine immediately.
    If no sync is done first, data will be lost."""
    st = _reboot(RB_HALT_SYSTEM)
    if st != 0:
        raise OSError, (errno, strerror(errno))     
def poweroff():
    """Poweroff the machine immediately.
    If no sync is done first, data will be lost."""
    st = _reboot(RB_POWER_OFF)
    if st != 0:
        raise OSError, (errno, strerror(errno)) 
