# Tiny bit of C code to invoke the 'clone' system call.
cdef extern from "sched.h":
    cdef enum:
        _CLONE_PARENT "CLONE_PARENT", _CLONE_FS "CLONE_FS",
        _CLONE_FILES "CLONE_FILES", _CLONE_NEWNS "CLONE_NEWNS",
        _CLONE_SIGHAND "CLONE_SIGHAND",_CLONE_PTRACE "CLONE_PTRACE",
        _CLONE_UNTRACED "CLONE_UNTRACED", _CLONE_STOPPED "CLONE_STOPPED",
        _CLONE_VFORK "CLONE_VFORK", _CLONE_VM "CLONE_VM",
        _CLONE_THREAD "CLONE_THREAD", _CLONE_SYSVSEM "CLONE_SYSVSEM",
        _CLONE_SETTLS "CLONE_SETTLS",
        _CLONE_PARENT_SETTID "CLONE_PARENT_SETTID",
        _CLONE_CHILD_SETTID "CLONE_CHILD_SETTID",
        _CLONE_CHILD_CLEARTID "CLONE_CHILD_CLEARTID"
cdef extern from "unistd.h":
    int syscall(int number, int flags, void *child_stack, int *parent_tidptr, int *child_tidptr)
cdef extern from "sys/syscall.h":
    cdef enum:
        SYS_clone

def clone(int flags):
    """Perform sys_clone() system call, which creates a new process in
    a manner similar to fork().  If flags is SIGCHLD, then this is
    identical to fork()."""
    return syscall(SYS_clone, flags, NULL, NULL, NULL)

CLONE_PARENT = _CLONE_PARENT
CLONE_FS = _CLONE_FS
CLONE_FILES = _CLONE_FILES
CLONE_NEWNS = _CLONE_NEWNS
CLONE_SIGHAND = _CLONE_SIGHAND
CLONE_PTRACE = _CLONE_PTRACE
CLONE_UNTRACED = _CLONE_UNTRACED
CLONE_STOPPED = _CLONE_STOPPED
CLONE_VFORK = _CLONE_VFORK
CLONE_VM = _CLONE_VM
CLONE_THREAD = _CLONE_THREAD
CLONE_SYSVSEM = _CLONE_SYSVSEM
CLONE_SETTLS = _CLONE_SETTLS
CLONE_PARENT_SETTID = _CLONE_PARENT_SETTID
CLONE_CHILD_SETTID = _CLONE_CHILD_SETTID
CLONE_CHILD_CLEARTID = _CLONE_CHILD_CLEARTID
